	.syntax unified

/* RCC offsets: */

	.set AHB1ENR,0x30
	.set AHB1LPENR,0x50
	.set APB2ENR,0x44
	.set APB2LPENR,0x64
	
	.set MODER,0x00
	.set TYPER,0x04
	.set OSPEEDR,0x08
	.set PUPDR,0x0c
	.set IDR,0x10
	.set ODR,0x14

	.set EXTICR1,0x08
	.set EXTICR2,0x0c
	.set EXTICR3,0x10
	.set EXTICR4,0x14

	.set IMR,0x00
	.set EMR,0x04
	.set RTSR,0x08
	.set FTSR,0x0c
	.set SWIER,0x10
	.set EXTIPR,0x14
	

	.text


	.globl  enable_GPIOA

enable_GPIOA:
	push {lr}

	ldr r0,=RCC
	ldr r1,[r0,#AHB1ENR]
	orr r1,r1,#1
	str r1,[r0,#AHB1ENR]
	ldr r1,[r0,#AHB1LPENR]
	orr r1,r1,#1
	str r1,[r0,#AHB1LPENR]
	isb
	dsb
	pop  {lr}



	.globl  enable_GPIOC

enable_GPIOC:
	push {lr}

	ldr r0,=RCC
	ldr r1,[r0,#AHB1ENR]
	orr r1,r1,#4
	str r1,[r0,#AHB1ENR]
	ldr r1,[r0,#AHB1LPENR]
	orr r1,r1,#4
	str r1,[r0,#AHB1LPENR]
	isb
	dsb
	pop {pc}

	.globl enable_LED2PA5

enable_LED2PA5:
	push {lr}
	ldr r0,=GPIOA
	ldr r1,[r0,#MODER]
	ldr r2,=1
	bfi r1,r2,#10,#2
	str r1,[r0,#MODER]
	ldr r1,[r0,#TYPER]
	bfc r1,#5,#1
	str r1,[r0,#TYPER]
	ldr r1,[r0,#OSPEEDR]
	orr r1,r1,#(3<<10)
	str r1,[r0,#OSPEEDR]
	pop {pc}


	.globl enable_button2PC13

enable_button2PC13:
	push {lr}
	ldr r0,=GPIOC
	ldr r1,[r0,#MODER]
	bfc r1,#26,#2
	str r1,[r0,#MODER]  /* GPIOC.MODER13 = Ob00 */
	ldr r1,[r0,#PUPDR]
	bfc r1,#26,#2
	str r1,[r0,#PUPDR]  /* GPIOC.MODER13 = Ob00 */
	pop {pc}

	.globl enable_SYSCFG

enable_SYSCFG:
	push {lr}
	ldr r0, =RCC
	ldr r1, [r0,#APB2ENR]
	orr r1, r1, #0x4000   /* 1 << 14	SYSCFGENR = 1 */
     	str r1, [r0, #APB2ENR]
	ldr r1, [r0,#APB2LPENR]
	orr r1, r1, #0x4000  /* 1 << 14	SYSCFGLPENR = 1 */
     	str r1, [r0, #APB2LPENR]	
	pop {pc}

	.globl init_IRQ_PC13

init_IRQ_PC13:
	push {lr}
	ldr r0,=SYSCFG
	ldr r1,[r0,#EXTICR4]
	bic r1, r1, #0xF0
	orr r1, r1, #0x20         /* EXTI13 = 0b0010 (PC13) pin */
	str r1,[r0,#EXTICR4] 	  /* SYSCFG_EXTICR4 */
	ldr r0,=EXTI
	ldr r1,[r0,#IMR]
	orr r1, r1, #(1<<13)       /* IT PC13 non masque (MR13) */
	str r1,[r0,#IMR] 	  /* EXTI_IMR */
	/* Rising trigger enable */
	ldr r1,[r0,#RTSR]
	orr r1, r1, #(1<<13)     /* IT TR13 rising trigger disable */
	str r1,[r0,#RTSR]        /* EXTI_RTSR */
	ldr r1,[r0,#FTSR]
	orr r1, r1, #(1<<13)      /* IT TR13 falling trigger enable */
	str r1,[r0,#FTSR]        /* EXTI_FTSR */
	ldr r1, =(1<<13)    	/* IT PR13 set to 1 */
	str r1,[r0,#EXTIPR] 	  /* clear  EXTI_PR13 */	
	/* IT enable */
	/* EXTI15_10 is IRQ#40 */
	/* ISER1 (1*32), bit 8 */
	.set ISER1,0X04
	ldr r0,=NVIC
	mov r1, #(1<<8)           
	str r1,[r0,#ISER1]  
	pop {pc}



