	.syntax unified

/* RCC offsets: */

	.set AHB1ENR,0x30
	.set AHB1LPENR,0x50
	.set APB2ENR,0x44
	.set APB2LPENR,0x64
	
	.set MODER,0x00
	.set TYPER,0x04
	.set OSPEEDR,0x08
	.set PUPDR,0x0c
	.set IDR,0x10
	.set ODR,0x14

	.set EXTICR1,0x08
	.set EXTICR2,0x0c
	.set EXTICR3,0x10
	.set EXTICR4,0x14

	.set IMR,0x00
	.set EMR,0x04
	.set RTSR,0x08
	.set FTSR,0x0c
	.set SWIER,0x10
	.set EXTIPR,0x14
	

	.data
CPT:	.word 0


	.text

	.globl main
	.thumb_func
main:
	/* enable GPIOA,GPIOC */
	bl enable_GPIOA	/* output LED */
	bl enable_GPIOC	/* input button */

	/* enable PA5 output to LED */	
	bl enable_LED2PA5	

	/* Enable SYSCFG */
	bl enable_SYSCFG	

	/* enable PC13 input from button */
	bl enable_button2PC13
	
	/* IRQ init from PC13 */
	bl init_IRQ_PC13
	
	ldr r0, =GPIOA
	ldr r1, [r0,#ODR]
	orr r1, r1, #0x20	/* turn off LED if bic r1, r1, #0x20, turn on if orr */
	str r1, [r0,#ODR]

loop:
	b loop

	mov pc,lr



	.globl EXTI15_10_Handler
	.thumb_func

EXTI15_10_Handler:
	push 	{r0, r1, lr}
	ldr r0, =EXTI
	ldr r1,[r0,#EXTIPR]
	tst r1,#(1<<13)
	beq laf  /* if not exti_13 we ignore */
	/* Clear pending register */
	ldr r1, =(1<<13)    	/* IT PR13 set to 1 */
	str r1,[r0,#EXTIPR] 	  /* clear  EXTI_PR13 */	
	ldr r0, =GPIOA
	ldr r1, [r0,#ODR]

	eor r1, r1, #0x20
	str r1, [r0,#ODR]	/* turn on or turn off LED with xor */

laf:	
	pop {r0, r1, pc}


